// created by Josh Heyde
// last updated 27/01/09

#pragma once
#include "C_WorldEntity.h"
#include "C_Vector.h"
#include <vector>

class C_FlockingEntity : public C_WorldEntity
{
public:
	C_FlockingEntity(const int &ID, const int &cF, const float &pX, const float &pY, const int &s, const int &rR, const int &mV);
	~C_FlockingEntity();

	// accessor and mutator functions
	const int getRepulsionRange() const {return repulsionRange;}
	void setRepulsionRange(const int &newRepulsionRange);
	const C_Vector* getDirection() const {return direction;}
	void setDirection(const int &newX, const int &newY);
	void setDirection(const C_Vector* newDirection);

	// other member functions
	void update();
	void render(const float &currentTime);
	void determineDirection(std::vector <C_WorldEntity*> v_entityVector);
	void controlVelocity();

	// behavioural functions
	C_Vector avoidance(std::vector <C_WorldEntity*> v_entityVector);
	C_Vector alignment(std::vector <C_WorldEntity*> v_entityVector);
	C_Vector cohesion(std::vector <C_WorldEntity*> v_entityVector);
private:
	int repulsionRange;
	C_Vector* direction;
	const int MAX_VELOCITY;
};
