#include "C_Scenery.h"
#include "C_Visualisation.h"
#include "C_Vector.h"

C_Scenery::C_Scenery(const int &ID, const float &pX, const float &pY, const int &h, const int &cF, const int &ht,
		const int &w, const int &s, const int &cV, const int &sr)
: C_WorldEntity(ID, pX, pY, h, cF, ht, w, s, cV), scrollRate(sr), scrollOffset(0)
{
	setActive(true);
}

C_Scenery::~C_Scenery(void)
{
}

// mutator functions
void C_Scenery::setScrollRate(const int &newScrollRate)
{
	scrollRate = newScrollRate;
}

void C_Scenery::setScrollOffset(const int &newScrollOffset)
{
	scrollOffset = newScrollOffset;
}

// other member functions

// renders the scenery
void C_Scenery::render(const float &currentTime)
{
	// interpolates the scrolling background
	scrollOffset += currentTime * scrollRate;

	VIS.drawBackground(graphicID, scrollOffset, currentFrame, (int&) currentPosition->x, (int&) currentPosition->y);
}

// updates the scenery
void C_Scenery::update()
{
	C_WorldEntity::update();
	// incrementing the offset
	scrollOffset += scrollRate;
}