// created by Josh Heyde
// last updated 25/01/09

#include "C_UI.h"
#include <HAPI_lib.h>
#include <assert.h>

// initialisation of the singleton
C_UI* C_UI::input = NULL;

// creation of a singleton
void C_UI::createInput()
{
	if(!input)
		input = new C_UI();
}

// deletion of a singleton
void C_UI::deleteInput()
{
	// error handling statements
	// asserting certain statements for this function
	assert(input != NULL);

	delete input;
}

//constructor
C_UI::C_UI()
{	
}

// destructor
C_UI::~C_UI()
{
}

// other member functions
void C_UI::refreshKeyboard()
{
	if(!HAPI->GetKeyboardData(&keyData))
		return;
}

// checks to see if the esc button has been pressed
bool C_UI::isEscPressed()
{
	refreshKeyboard();
	return keyData.scanCode[HK_ESCAPE];
}

// mouse member functions
void C_UI::refreshMouse()
{
	if(!HAPI->GetMouseData(&mData))
		return;
}

// checks to see if the left mouse button has been pressed
bool C_UI::isLeftButtonClicked()
{
	refreshMouse();
	return mData.leftButtonDown;
}

// checks to see if the right mouse button has been pressed
bool C_UI::isRightButtonClicked()
{
	refreshMouse();
	return mData.rightButtonDown;
}

// returns the current mouse position in vector form
C_Vector C_UI::getMousePosition()
{
	refreshMouse();

	C_Vector temp(mData.x, mData.y);
	return temp;
}

