// created by Josh Heyde
// last updated 25/01/09

#pragma once

#include <vector>

class C_WorldEntity;

class C_World
{
public:
	~C_World();
	
	// other member functions
	bool initialise();
	void loadData();
	void getInput();
	void update();
	void draw(const float &tick);

	// create singleton
	static void createWorld();
	// get singleton
	static C_World& getWorld() {return *world;}
	// delete singleton
	static void deleteWorld();

private:
	// constructor
	C_World();

	std::vector <C_WorldEntity*> v_entityVector;

	// singleton
	static C_World* world;

	// model tick members
	const float DELAY;
	float previousTime;
	float currentTime;
};

#define WORLD C_World::getWorld()